import os
import subprocess
import psutil
import winreg

def set_process_priority(process_name, priority=psutil.HIGH_PRIORITY_CLASS):
    for proc in psutil.process_iter():
        try:
            if process_name.lower() in proc.name().lower():
                proc.nice(priority)
                print(f"Priorité du processus {proc.name()} réglée sur haute.")
        except (psutil.NoSuchProcess, psutil.AccessDenied, psutil.ZombieProcess):
            pass

def optimize_graphics_settings():
    fortnite_settings_path = os.path.join(os.getenv('LOCALAPPDATA'), 'FortniteGame', 'Saved', 'Config', 'WindowsClient', 'GameUserSettings.ini')
    if os.path.exists(fortnite_settings_path):
        try:
            with open(fortnite_settings_path, 'r+') as file:
                content = file.read()
                content = content.replace('sg.ResolutionQuality=100.000000', 'sg.ResolutionQuality=80.000000')
                content = content.replace('sg.ViewDistanceQuality=3', 'sg.ViewDistanceQuality=1')
                content = content.replace('sg.AntiAliasingQuality=3', 'sg.AntiAliasingQuality=0')
                content = content.replace('sg.ShadowQuality=3', 'sg.ShadowQuality=0')
                content = content.replace('sg.PostProcessQuality=3', 'sg.PostProcessQuality=0')
                content = content.replace('sg.TextureQuality=3', 'sg.TextureQuality=1')
                content = content.replace('sg.EffectsQuality=3', 'sg.EffectsQuality=1')
                content = content.replace('sg.FoliageQuality=3', 'sg.FoliageQuality=0')
                content = content.replace('sg.ShadingQuality=3', 'sg.ShadingQuality=1')
                file.seek(0)
                file.write(content)
                file.truncate()
            print("Les paramètres graphiques de Fortnite ont été optimisés.")
        except Exception as e:
            print(f"Erreur lors de la modification des paramètres graphiques : {e}")
    else:
        print("Impossible de localiser le fichier GameUserSettings.ini pour Fortnite.")

def free_memory():
    try:
        subprocess.run("EmptyStandbyList.exe workingsets", shell=True)
        subprocess.run("EmptyStandbyList.exe standbylist", shell=True)
        print("Mémoire libérée avec succès.")
    except Exception as e:
        print(f"Erreur lors du nettoyage de la mémoire : {e}")

def disable_unnecessary_services():
    services_to_disable = [
        'SysMain',
        'DiagTrack',
        'WSearch'
    ]
    for service in services_to_disable:
        try:
            subprocess.run(f"sc stop {service}", shell=True)
            subprocess.run(f"sc config {service} start= disabled", shell=True)
            print(f"Service {service} désactivé.")
        except Exception as e:
            print(f"Erreur lors de la désactivation du service {service} : {e}")

def optimize_virtual_memory():
    try:
        subprocess.run("wmic computersystem where name=\"%computername%\" set AutomaticManagedPagefile=False", shell=True)
        subprocess.run("wmic pagefileset where name=\"C:\\\\pagefile.sys\" set InitialSize=4096,MaximumSize=8192", shell=True)
        print("Mémoire virtuelle optimisée.")
    except Exception as e:
        print(f"Erreur lors de l'optimisation de la mémoire virtuelle : {e}")

def set_fortnite_priority():
    set_process_priority("FortniteClient-Win64-Shipping.exe", psutil.HIGH_PRIORITY_CLASS)

def disable_game_dvr():
    try:
        key = winreg.OpenKey(winreg.HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\GameDVR", 0, winreg.KEY_ALL_ACCESS)
        winreg.SetValueEx(key, "AppCaptureEnabled", 0, winreg.REG_DWORD, 0)
        winreg.SetValueEx(key, "GameDVR_Enabled", 0, winreg.REG_DWORD, 0)
        winreg.CloseKey(key)
        print("Game DVR désactivé.")
    except Exception as e:
        print(f"Erreur lors de la désactivation de Game DVR : {e}")

def optimize_fortnite():
    print("Optimisation de Fortnite pour gagner des FPS...")
    
    optimize_graphics_settings()
    
    optimize_virtual_memory()
    
    disable_unnecessary_services()
    
    free_memory()
    
    set_fortnite_priority()
    
    disable_game_dvr()

    print("Optimisation complète terminée pour Fortnite.")

if __name__ == "__main__":
    optimize_fortnite()
